package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

//import java.util.Calendar;
//import java.util.Map;
//import java.math.BigDecimal;

public interface CallableStatement extends PreparedStatement {

   public void registerOutParameter(int parameterIndex, int sqlType) throws SQLException;

   public void registerOutParameter(int parameterIndex, int sqlType, int scale) 
      throws SQLException;

   public boolean wasNull() throws SQLException;

   public String getString(int parameterIndex) throws SQLException;

   public boolean getBoolean(int parameterIndex) throws SQLException;

   public byte getByte(int parameterIndex) throws SQLException;

   public short getShort(int parameterIndex) throws SQLException;

   public int getInt(int parameterIndex) throws SQLException;

   public long getLong(int parameterIndex) throws SQLException;

   public float getFloat(int parameterIndex) throws SQLException;

   public double getDouble(int parameterIndex) throws SQLException;

   public byte[] getBytes(int parameterIndex) throws SQLException;

   public Date getDate(int parameterIndex) throws SQLException;

   public Time getTime(int parameterIndex) throws SQLException;

   public Timestamp getTimestamp(int parameterIndex) throws SQLException;

   public Object getObject(int parameterIndex) throws SQLException;

   public Ref getRef(int i) throws SQLException;

   public Blob getBlob(int i) throws SQLException;

   public Clob getClob(int i) throws SQLException;

   public Array getArray(int i) throws SQLException;

//   public Date getDate(int parameterIndex, Calendar cal) throws SQLException;

//   public Time getTime(int parameterIndex, Calendar cal) throws SQLException;

//   public Timestamp getTimestamp(int parameterIndex, Calendar cal) throws SQLException;

   public void registerOutParameter(int paramIndex, int sqlType, String typeName)
      throws SQLException;

}

