package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

public class DataTruncation extends SQLWarning {

   private int index;
   private boolean parameter;
   private boolean read;
   private int dataSize;
   private int transferSize;

   public DataTruncation(int index, boolean parameter, boolean read,
                         int dataSize, int transferSize)
   {
      super("Data truncation", "01004");

      this.index = index;
      this.parameter = parameter;  
      this.read = read;
      this.dataSize = dataSize;
      this.transferSize = transferSize;
/*
      DriverManager.println("DataTruncation:  index=" + index +
                            " parameter=" + parameter +
                            " read=" + read +
                            " data size=" + dataSize +
                            " transfer size" + transferSize);
*/
   }

   public int getDataSize()
   {
      return dataSize;
   }

   public int getIndex()
   {
      return index;
   }

   public boolean getParameter()
   {
      return parameter;
   }

   public boolean getRead()
   {
      return read;
   }

   public int getTransferSize()
   {
      return transferSize;
   }

}

