package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

// import java.math.BigDecimal;
import java.io.InputStream;
// import java.io.Reader;

public interface SQLOutput {

   public void writeString(String x) throws SQLException;

   public void writeBoolean(boolean x) throws SQLException;

   public void writeByte(byte x) throws SQLException;

   public void writeShort(short x) throws SQLException;

   public void writeInt(int x) throws SQLException;

   public void writeLong(long x) throws SQLException;

   public void writeFloat(float x) throws SQLException;

   public void writeDouble(double x) throws SQLException;

//   public void writeBigDecimal(BigDecimal x) throws SQLException;

   public void writeBytes(byte[] x) throws SQLException;

   public void writeDate(Date x) throws SQLException;

   public void writeTime(Time x) throws SQLException;

   public void writeTimestamp(Timestamp x) throws SQLException;

//   public void writeCharacterStream(Reader x) throws SQLException;

   public void writeAsciiStream(InputStream x) throws SQLException;

   public void writeBinaryStream(InputStream x) throws SQLException;

   public void writeObject(SQLData x) throws SQLException;

   public void writeRef(Ref x) throws SQLException;

   public void writeBlob(Blob x) throws SQLException;

   public void writeClob(Clob x) throws SQLException;

   public void writeStruct(Struct x) throws SQLException;

   public void writeArray(Array x) throws SQLException;

}

