package java.sql;

/* 
 * Licensed Materials - Property of IBM,
 * (c) Copyright IBM Corp. 1998, 2000 All Rights Reserved
 */

public interface Statement {

   public ResultSet executeQuery(String sql) throws SQLException;

   public int executeUpdate(String sql) throws SQLException;

   public void close() throws SQLException;

   public int getMaxFieldSize() throws SQLException;

   public void setMaxFieldSize(int max) throws SQLException;

   public int getMaxRows() throws SQLException;

   public void setMaxRows(int max) throws SQLException;

   public void setEscapeProcessing(boolean enable) throws SQLException;

   public int getQueryTimeout() throws SQLException;

   public void setQueryTimeout(int seconds) throws SQLException;

   public void cancel() throws SQLException;

   public SQLWarning getWarnings() throws SQLException;

   public void clearWarnings() throws SQLException;

   public void setCursorName(String name) throws SQLException;

   public boolean execute(String sql) throws SQLException;

   public ResultSet getResultSet() throws SQLException;

   public int getUpdateCount() throws SQLException;

   public boolean getMoreResults() throws SQLException;

   public void setFetchDirection(int direction) throws SQLException;

   public int getFetchDirection() throws SQLException;

   public void setFetchSize(int rows) throws SQLException;

   public int getFetchSize() throws SQLException;

   public int getResultSetConcurrency() throws SQLException;

   public int getResultSetType() throws SQLException;

   public void addBatch(String sql) throws SQLException;

   public void clearBatch() throws SQLException;

   public int[] executeBatch() throws SQLException;

   public Connection getConnection() throws SQLException;

}

