///////////////////////////////////////////////////////////////
//
// Source File Name = SampleCLP.h
//
// (C) Copyright IBM Corp. 2000, 2001
// All Right Reserved.
// Licensed Materials - Property of IBM
// 
// DB2 Everyplace Sample Application - CLP
// 
// This application demonstrates how to use CLI to
// write a simple command line processor that 
// accepts SQL statements and execute them.
// This application is portable to different platforms:
//    PalmOS, Neutrino, E. Linux, WinCE, Win32, and EPOC.
// It also includes import/export tools.
//
///////////////////////////////////////////////////////////////

#ifndef _SAMPLECLP_H_
#define _SAMPLECLP_H_

#if defined (__SYMBIAN32__) //a3894kmt && defined (__PSISOFT32__) && (defined (__EPOC32__) || defined (__VC32__))
#define oEPOC
#elif defined (__PALM_OS_TRAPS__) || defined (__palmos__)
#define oPALMOS
#elif defined (_WIN32_WCE)
#define oWINCE
#endif

//Palm CLP begin --- for the function mapping in following 
#if defined(oPALMOS)
#include "memorw.h"
#endif 
//Palm CLP end


#if !defined(oWINCE) && !defined(oPALMOS)//Palm CLP
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#endif

#if defined(oWINCE)
#include "Res.h"
#include "sqlcli1.h"
#include "LView.h"
#include <commctrl.h>
#else
#include "sqlcli.h"
#endif

#if defined (oEPOC) && defined(UNICODE) //a3894kmt
  #define TEXT(s) L ## s
  #include <wtlstd.h>
  #include <wtlstr.h>
  #define NOSSCANF // activate the code replacing sscanf (a3894kmt)
#endif

#if defined(WIN32U) //07132001ctl
#include <TCHAR.H>
#endif

#if !defined(_TEXT ) && defined(UNICODE)
#define _TEXT(d) TEXT(d)
#endif
#if !defined(_TEXT ) && !defined(UNICODE)
#define _TEXT(d) d
#endif

//Palm CLP begin
#if defined(oPALMOS)
#define NOSSCANF  // activate the code replacing sscanf (a3894kmt)
#define malloc(c)            MemPtrNew(c)
#define free(c)              MemPtrFree(c)
#define memset(dst,c,n)      MemSet(dst,n,c)
#define memcpy(dst,src,n)    MemMove(dst,src,n)
#define TEXT(s)              s   // used for char constants  
#define _tcscmp(s1, s2)      StrCompare((char *) s1, (char *) s2)
#define _tcsncmp(s1,s2,n)    StrNCompare((char *) s1, (char *) s2, n)           
#define _tcscpy(s1,s2)       StrCopy((char *) s1, (char *) s2)
#define _tcsncpy(s1,s2,n)    StrNCopy((char *) s1, (char *) s2,n)
#define _tcslen(s)           StrLen((char *) s)
#define _stprintf            StrPrintF
#define _tcscat(s1, s2)      StrCat((char *)s1, (const char*)s2)
#define _stscanf             oSscanf
#define _tcsstr(s1, s2)      StrStr((const char*)s1, (const char*)s2)
#define _tcsAtoI             StrAToI
#define atoi(s)              StrAToI((char*)s)
#define _tprintf             
  
//following is implemented in SampleCLP.c
void CLPStdout(char* str);
char oToUpper(char c);
  
#else
//Palm CLP end 
#if (WIN32U) //d3753ctl
#ifndef _tprintf
#define _tprintf wprintf
#endif

#ifndef _stprintf
#define _stprintf swprintf
#endif
    
#ifndef _tcsncpy
#define _tcsncpy wstrncpy
#endif
    
#ifndef _tcsncmp
#define _tcsncmp wstrncmp
#endif
    
#ifndef _tcscmp
#define _tcscmp wstrcmp
#endif
    
#ifndef _tcscpy
#define _tcscpy wstrcpy
#endif
    
#ifndef _tcscat
#define _tcscat wstrcat
#endif
    
#ifndef _tcslen
#define _tcslen wstrlen
#endif
    
#ifndef _stscanf
#define _stscanf swscanf
#endif
#else
#ifndef _tprintf
#define _tprintf printf
#endif

#ifndef _stprintf
#define _stprintf sprintf
#endif
    
#ifndef _tcsncpy
#define _tcsncpy strncpy
#endif
    
#ifndef _tcsncmp
#define _tcsncmp strncmp
#endif
    
#ifndef _tcscmp
#define _tcscmp strcmp
#endif
    
#ifndef _tcscpy
#define _tcscpy strcpy
#endif
    
#ifndef _tcscat
#define _tcscat strcat
#endif
    
#ifndef _tcslen
#define _tcslen strlen
#endif
    
#ifndef _stscanf
#define _stscanf sscanf
#endif

#ifndef _tcsstr
#define _tcsstr strstr
#endif

#endif  
    
#endif  

#if defined (oEPOC) && defined(UNICODE) //a3894kmt
//a4111kmt
#undef _tprintf
#undef _stscanf
#undef _stprintf
#undef _tcsstr
#undef _tcsAtoI
#undef _tcsncpy
#undef _tcsncmp
#undef _tcscmp
#undef _tcscpy
#undef _tcscat
#undef _tcslen

#define _tprintf
#define _stscanf
#define _stprintf  Wtl_Sprintf16
#define _tcsstr    e32strstr16
#define _tcsAtoI   e32atoi16
#define _tcsncpy   e32strncpy16
#define _tcsncmp   e32strncmp16
#define _tcscmp    e32strcmp16
#define _tcscpy    e32strcpy16
#define _tcscat    e32strcat16
#define _tcslen    e32strlen16
#endif

/////////////////////////////////////////////////////////////////////
// support for the $chmod command used in clp
/////////////////////////////////////////////////////////////////////

#define DB2eCLP_STMTATTR_UNCHANGED     0
#define DB2eCLP_STMTATTR_SET_MODE1     1
#define DB2eCLP_STMTATTR_SET_MODE2     2
#define DB2eCLP_STMTATTR_SET_MODE3     3
#define DB2eCLP_STMTATTR_SET_MODE4     4
#define DB2eCLP_STMTATTR_SET_MODE5     5
#define DB2eCLP_STMTATTR_SET_MODE6     6
#define DB2eCLP_STMTATTR_SET_MODE7     7
#define DB2eCLP_STMTATTR_SET_MODE8     8
#define DB2eCLP_STMTATTR_SET_MODE9     9

// support for IE tool and chmod command
#define CLP_CHMOD_OK         0
#define CLP_CHMOD_ERROR      1
#define CLP_IETOOL_ERROR     -1
//////////////////////////////////////////////////////////////////

#define MSGSIZE            512
#define SZUSERNAME         40
#define SZPASSWORD         40
#define SZPATH             100 
#define BUFSIZE            128
#define PARTSIZE           80 //d4480xh 
#define EXTRA_SPACES       100
#define TEN_SPACES          10
#if defined(oWINCE) || (defined (oEPOC) && defined(UNICODE)) //a3894kmt
#define MAX_CMD_LEN       2048*sizeof(SQLTCHAR) 
#else
#define MAX_CMD_LEN       2048
#endif
#define MAX_SQL_LEN       2048 // max. sql statement length
#define CLP_CONTINUE         1
#define CLP_QUIT             0

#define CLP_INTERACT_DEVICE  0  // default; no echo of column names for queries
#define CLP_INTERACT         1
#define CLP_EXPORT           2
#define CLP_TABLE_MODE       4  // 04022001ctl

// 04022001ctl begin
#define TSTBIT(x,flag) (x & flag)
#define SETBIT(x,flag) (x |= flag)
#define CLRBIT(x,flag) (x &= ~flag)
// 04022001ctl end

#define DECIMAL_POINT 1
#define SIGN          1

#define ID_LEN 128
#define EXTRA_SPACE   1

#ifndef _OUINT32
#define _OUINT32
typedef unsigned long OUINT32;
#endif

#if defined(oWINCE)
typedef HANDLE      o_FILE;
#else 
#if defined(oPALMOS)  //Palm CLP
typedef memoFILE o_FILE;  
#else 
typedef FILE o_FILE;
#endif     
#endif     


#if defined(oWINCE) //d3041
#define Uchar      unsigned char 
// define code pages
#define EncodingCP932         932            //japanese
#define EncodingCP1252        1252           //sbcs
#define EncodingUTF8          1208           //CP1208 is UTF8
#define EncodingCP936         936            //simplified chinese
#define EncodingCP950         950            //traditional chinese (950 come from WinNT) (M2314TP)
#define EncodingCP949         949            //Korean   (A843 TP)

// Japanese Palm uses CP932 (is it the same as CP943, CP942?)
#define FirstByteCP932(c)     (( c>=0x81 && c<=0x9F) || (c>=0xE0 && c<=0xFC))

// simplified chinese. cp936   d0411jhc M2314TP
#define FirstByteCP936(c)     (c>=0x81 && c<=0xFE)

//traditional chinese. CP950   d0411jhc
#define FirstByteCP950(c)     (c>=0x81 && c<=0xFE)

//Korean. (A843TP) 
#define FirstByteCP949(c)     (c>=0x81 && c<=0xFE)
#endif


// Save state information for CLP
typedef struct _CLPState
{
    SQLHENV   henv;
    SQLHDBC   hdbc;
    SQLHSTMT  hstmt;
    int     flag_hstmt; //d4421 xh 101201
    int     current_mhstmt;//d4421 xh 101201
	SQLHSTMT  mhstmt[20];  // d4254qz 
	int       mstmtno;    // d4254qz
	SQLTCHAR **  bindarray[20];  // d4254qz
    int       stmtCtrl; // stmt mode
    o_FILE    *fpIN;    // for input file
    o_FILE    *fpOUT;   // for output file
    SQLHSTMT  outhstmt;      // for storing the output in a table ($table command) // 04022001ctl
    long      outTablecount; // the sequence number of the rows ($table command)   // 04022001ctl
    SQLTCHAR  outTable[20];  // output table name                                  // 04022001ctl
    int       outTableTextLen; // column length for storing result                 // 04022001ctl
    int       mode;            // CLP_INTERACT, CLP_EXPORT...
    int       regtest;         // d2786akl
    //following string will bring out any error report from
    //Import/Export tool and $chmod command, but
    //for $chmod command it can also be some prompt info.
    SQLTCHAR  sqlstate[SQL_SQLSTATE_SIZE + 1];
    SQLTCHAR  err_string[MAX_CMD_LEN];
    SQLTCHAR  cmd[MAX_CMD_LEN];
#if defined(oEPOC)
    SQLTCHAR  username[SZUSERNAME];
    SQLTCHAR  password[SZPASSWORD];
    SQLTCHAR  path[SZPATH];
    SQLTCHAR  msg[MSGSIZE];
    void*     epSupport;
#endif
} CLPState;

typedef struct _DataTypes
{
    SQLTCHAR     colname[32];
    SQLUSMALLINT colnamelen;
    SQLSMALLINT  coltype;
    SQLUINTEGER  collen;
    SQLSMALLINT  scale;
    SQLSMALLINT  nullable;
} DataTypes;


// interfaces
SQLRETURN CLPSetStmtMode(CLPState *clpstate);
SQLRETURN CLPStartEngine(CLPState *clpstate);
void      CLPStopEngine(CLPState *clpstate);
SQLRETURN CLPExecStatement(CLPState *clpstate);
int       CLPcommand_interpreter(CLPState *clpstate);
  
/*
#if defined(oWINCE)
int callable_CLP(SQLHENV  henv, SQLHDBC  hdbc, SQLHSTMT hstmt, SQLTCHAR *cmd, HWND hwndLV);
#else
int callable_CLP(SQLHENV  henv, SQLHDBC  hdbc, SQLHSTMT hstmt, SQLTCHAR *cmd);
#endif
*/
#if defined(oWINCE)
int callable_CLP(CLPState *clpstate, HWND hwndLV);
#else
int callable_CLP(CLPState *clpstate);
#endif

#if defined(oWINCE)

int o_Feof(o_FILE* stream);
int o_Fflush(o_FILE* stream);
OUINT32 o_Fread(void* buffer,
                OUINT32 element_size,
                OUINT32 count,
                o_FILE* stream);
OUINT32 o_Fwrite(SQLTCHAR *buffer,
                 OUINT32   element_size,
                 OUINT32   count,
                 o_FILE    *stream);
int o_Fclose(o_FILE* stream);
o_FILE *o_Fopen (SQLTCHAR *filename,
                 SQLTCHAR *mode);
SQLTCHAR oToUpper(SQLTCHAR c);

#else
//Palm CLP begin
#if defined(oPALMOS)
//#define EOF 1
#define stdin 0
#define stdout 1
#define o_Feof(stream)                             memoFeof(stream)
#define o_Fflush(stream)                           memoFflush(stream)
#define o_Fread(buffer,element_size,count,stream)  memoFread(buffer,element_size,count,stream)
#define o_Fwrite(buffer,element_size,count,stream) memoFwrite(buffer,element_size,count,stream)
#define o_Fclose(stream)                           memoFclose(stream)
#define o_Fopen(filename, mode)                    memoFopen(filename, mode)
#else
#define o_Feof(stream)                             feof(stream)
#define o_Fflush(stream)                           fflush(stream)
#define o_Fread(buffer,element_size,count,stream)  fread(buffer,element_size,count,stream)
#define o_Fwrite(buffer,element_size,count,stream) fwrite(buffer,element_size,count,stream)
#define o_Fclose(stream)                           fclose(stream)
#if defined(oEPOC) && defined(_UNICODE) //a4111kmt
  #define o_Fopen                                  wfopen
#else
  #define o_Fopen(filename, mode)                  fopen(filename, mode)
#endif
#define oToUpper(c)                                toupper(c)
#endif
#endif 
//Palm CLP end

// oSscanf is for Palm and EPOC as their sscanf if missing or not sufficient
// but it has limited funcionality
int oSscanf(SQLTCHAR *buf, SQLTCHAR *formatprec,
            SQLTCHAR *res1, SQLTCHAR *res2, SQLTCHAR *res3);
//#endif 

#endif


